Index: drivers/scsi/qla1280.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/qla1280.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/qla1280.c	22 Jul 2004 19:50:06 -0000	1.1
+++ drivers/scsi/qla1280.c	4 Aug 2004 01:29:36 -0000	1.2
@@ -1038,246 +1216,86 @@
  * handling).   Unfortunely, it sometimes calls the scheduler in interrupt
  * context which is a big NO! NO!.
  **************************************************************************/
-int
-qla1280_queuecommand(Scsi_Cmnd *cmd, void (*fn)(Scsi_Cmnd *))
+static int
+qla1280_queuecommand(Scsi_Cmnd * cmd, void (*fn) (Scsi_Cmnd *))
 {
-    scsi_qla_host_t *ha;
-    srb_t  *sp;
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
-    unsigned long cpu_flags = 0;
-#endif
-    struct Scsi_Host *host;
-    uint32_t        b, t, l;
-    scsi_lu_t       *q;
-    u_long          handle;
-
-    ENTER("qla1280_queuecommand");
-    COMTRACE('C') 
-
-    host = cmd->host;
-    ha = (scsi_qla_host_t *) host->hostdata;
-
-    /* send command to adapter */
-    sp = (srb_t *) CMD_SP(cmd);
-    sp->cmd =  cmd;
-    cmd->scsi_done = fn;
-    if (cmd->flags == 0)  /* new command */
-    {
-        sp->flags = 0;
-    }
-
-    DEBUG5(qla1280_print_scsi_cmd(cmd));
-
-    /* Generate LU queue on bus, target, LUN */
-    b = SCSI_BUS_32(cmd);
-    t = SCSI_TCN_32(cmd);
-    l = SCSI_LUN_32(cmd);
-    if((q = LU_Q(ha, b, t, l)) == NULL )
-    {
-        DRIVER_LOCK
-        if( (q = (scsi_lu_t *)KMALLOC(sizeof(struct scsi_lu))) )
-        {
-           LU_Q(ha, b, t, l) = q;
-           BZERO(q,sizeof(struct scsi_lu));
-           DEBUG(sprintf(debug_buff,"Allocate new device queue 0x%x\n",q));
-           DEBUG(qla1280_print(debug_buff));
-           DRIVER_UNLOCK
-        }
-        else
-        {
-            CMD_RESULT(cmd) = (int) (DID_BUS_BUSY << 16);
-            qla1280_done_q_put(sp, &ha->done_q_first, &ha->done_q_last);
-
-            schedule_task(&ha->run_qla_bh);
-            ha->flags.dpc_sched = TRUE;
-            DRIVER_UNLOCK
-            return(0);
-        }
-    }
-    /* Set an invalid handle until we issue the command to ISP */
-    /* then we will set the real handle value.                 */
-    handle = INVALID_HANDLE;  
-    CMD_HANDLE(cmd) = (unsigned char *)handle;
-
-    /* Bookkeeping information */
-    sp->r_start = jiffies;       /* time the request was received */
-    sp->u_start = 0;              
-
-    /* add the command to our queue */
-    ha->qthreads++;
-    qla1280_putq_t(q,sp);
-    
-    DEBUG(sprintf(debug_buff,"qla1280_queuecmd: queue pid=%d, hndl=0x%x\n\r",cmd->pid,handle));
-    DEBUG(qla1280_print(debug_buff));
-
-    /* send command to adapter */
-    DRIVER_LOCK
-        if (q->q_outcnt == 0)
-            qla1280_restart_queues(ha);
-    DRIVER_UNLOCK
-    
-    
-    LEAVE("qla1280_queuecommand");
-    return (0);
+	struct scsi_qla_host *ha;
+	struct srb *sp;
+	struct Scsi_Host *host;
+	int bus, target, lun;
+	int status;
+
+	/*ENTER("qla1280_queuecommand");
+	 */
+	dprintk(2, "qla1280_queuecommand(): jiffies %li\n", jiffies);
+
+	host = CMD_HOST(cmd);
+	ha = (struct scsi_qla_host *)host->hostdata;
+
+	/* send command to adapter */
+	sp = (struct srb *)CMD_SP(cmd);
+	sp->cmd = cmd;
+	cmd->scsi_done = fn;
+	sp->flags = 0;
+
+	qla1280_print_scsi_cmd(5, cmd);
+
+	/* Generate LU queue on bus, target, LUN */
+	bus = SCSI_BUS_32(cmd);
+	target = SCSI_TCN_32(cmd);
+	lun = SCSI_LUN_32(cmd);
+	if (ha->flags.enable_64bit_addressing)
+		status = qla1280_64bit_start_scsi(ha, sp);
+	else
+		status = qla1280_32bit_start_scsi(ha, sp);
+
+	/*LEAVE("qla1280_queuecommand"); */
+	return status;
 }
 
-/**************************************************************************
- *   qla1200_abort
- *     Abort the speciifed SCSI command(s).
- **************************************************************************/
-int
-qla1280_abort(Scsi_Cmnd *cmd)
+enum action {
+	ABORT_COMMAND,
+	ABORT_DEVICE,
+	DEVICE_RESET,
+	BUS_RESET,
+	ADAPTER_RESET,
+	FAIL
+};
+
+/* timer action for error action processor */
+static void qla1280_error_wait_timeout(unsigned long __data)
+{
+	struct scsi_cmnd *cmd = (struct scsi_cmnd *)__data;
+	struct srb *sp = (struct srb *)CMD_SP(cmd);
+
+	complete(sp->wait);
+}
+
+static void qla1280_mailbox_timeout(unsigned long __data)
 {
-    scsi_qla_host_t *ha;
-    srb_t  *sp;
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
-    unsigned long cpu_flags = 0;
-#endif
-    struct Scsi_Host *host;
-    uint32_t        b, t, l;
-    scsi_lu_t       *q;
-    int return_status = SCSI_ABORT_SUCCESS;
-    int found = 0;
-    int i;
-    u_long     handle;
-    u_short    data;
-
-    ENTER("qla1280_abort");
-    COMTRACE('A')
-    ha = (scsi_qla_host_t *) cmd->host->hostdata;
-    host = cmd->host;
-    DRIVER_LOCK
-
-    /* Get the SCSI request ptr */
-    sp = (srb_t *) CMD_SP(cmd);
-    handle = (u_long) CMD_HANDLE(cmd);
-    if (qla1280_verbose)
-        printk("scsi(%d): ABORT Command=0x%lx, handle=0x%lx\n",(int)ha->host_no,(long)cmd,handle);
-
-    /* Check for pending interrupts. */
-    if( handle == 0L )
-    {
-    COMTRACE('a')
-        /* we never got this command */
-        printk(KERN_INFO "qla1280: Aborting a NULL handle\n");
-        DRIVER_UNLOCK
-                return(SCSI_ABORT_NOT_RUNNING);  /* no action - we don't have command */
-    }
-    data = qla1280_debounce_register(&ha->iobase->istatus);
-    if( !(ha->flags.in_isr) && (data & RISC_INT) )
-    {
-        /* put any pending command in done queue */
-        qla1280_isr(ha, (srb_t **)&ha->done_q_first, (srb_t **)&ha->done_q_last);
-    }
-
-    handle = (u_long) CMD_HANDLE(cmd);
-
-    /* Generate LU queue on bus, target, LUN */
-    b = SCSI_BUS_32(cmd);
-    t = SCSI_TCN_32(cmd);
-    l = SCSI_LUN_32(cmd);
-    if((q = LU_Q(ha, b, t, l)) == NULL )
-    {
-    COMTRACE('a')
-        /* No lun queue -- command must not be active */
-        DRIVER_UNLOCK
-        printk(KERN_WARNING "qla1280 (%d:%d:%d): No LUN queue for the specified device\n",(int)b,(int)t,(int)l);
-        return(SCSI_ABORT_NOT_RUNNING);  /* no action - we don't have command */
-    }
-
-#if AUTO_ESCALATE_ABORT
-    if ( (sp->flags & SRB_ABORTED) )
-    {
-        DRIVER_UNLOCK
-        DEBUG(qla1280_print("qla1280_abort: Abort escalayted - returning SCSI_ABORT_SNOOZE.\n\r"));
-        return(SCSI_ABORT_SNOOZE);
-    }
-#endif
-
-    if ( (sp->flags & SRB_ABORT_PENDING) )
-    {
-    COMTRACE('a')
-        DRIVER_UNLOCK
-        if( qla1280_verbose  )
-            printk("scsi(): Command has a pending abort message - ABORT_PENDING.\n");
-        DEBUG(qla1280_print("qla1280: Command has a pending abort message - ABORT_PENDING.\n\r"));
-        return(SCSI_ABORT_PENDING);
-    }
-
-#if  STOP_ON_ABORT 
-    printk("Scsi layer issued a ABORT command= 0x%x\n",(int)cmd);
-    DEBUG2(qla1280_print_scsi_cmd(cmd));
-#endif
-
-    ha->flags.in_abort = TRUE;
-    /*
-    * Normally, would would need to search our queue for the specified command
-    * but; since our sp contains the cmd ptr, we can just remove it from our
-    * LUN queue.
-    */
-    if( !(sp->flags&SRB_SENT) )
-    { 
-        found++;
-        if( qla1280_verbose  )
-            printk("scsi(): Command returned from queue aborted.\n");
-        DEBUG(qla1280_print("qla1280: Command returned from queue aborted.\n\r"));
-        /* Remove srb from SCSI LU queue. */
-        qla1280_removeq(q, sp);
-        sp->flags |=  SRB_ABORTED;
-        CMD_RESULT(cmd) = DID_ABORT << 16; 
-        qla1280_done_q_put(sp, &ha->done_q_first, &ha->done_q_last);
-        return_status = SCSI_ABORT_SUCCESS;
-    }
-    else
-    {  /* find the command in our active list */
-        for (i = 1; i < MAX_OUTSTANDING_COMMANDS; i++)
-        {
-            if( sp == ha->outstanding_cmds[i] )
-            {
-                found++;
-                DEBUG(qla1280_print("qla1280: RISC aborting command.\n\r"));
-                qla1280_abort_command(ha,sp);
-                return_status = SCSI_ABORT_PENDING;
-                break;
-            }
-        }
-    }
-
-#if  STOP_ON_ABORT 
-    qla1280_panic("qla1280_abort",ha->host);
-#endif
-    if ( found == 0 )
-        return_status = SCSI_ABORT_NOT_RUNNING;  /* no action - we don't have command */
-
-    DEBUG(sprintf(debug_buff, "qla1280_abort: Aborted status returned = 0x%x.\n\r",return_status));
-    DEBUG(qla1280_print(debug_buff));
-
-    if( ha->done_q_first )
-       qla1280_done(ha, (srb_t **)&ha->done_q_first, (srb_t **)&ha->done_q_last);
-    if ( found )
-    {
-        qla1280_restart_queues(ha);
-    }
-    ha->flags.in_abort = FALSE;
-    DRIVER_UNLOCK
-
-    LEAVE("qla1280_abort");
-    COMTRACE('a')
-    return(return_status);
+	struct scsi_qla_host *ha = (struct scsi_qla_host *)__data;
+	struct device_reg *reg;
+	reg = ha->iobase;
+
+	ha->mailbox_out[0] = RD_REG_WORD(&reg->mailbox0);
+	printk(KERN_ERR "scsi(%ld): mailbox timed out, mailbox0 %04x, "
+	       "ictrl %04x, istatus %04x\n", ha->host_no, ha->mailbox_out[0],
+	       RD_REG_WORD(&reg->ictrl), RD_REG_WORD(&reg->istatus));
+	complete(ha->mailbox_wait);
 }
 
 /**************************************************************************
- * qla1200_reset
- *    The reset function will reset the SCSI bus and abort any executing
- *    commands. 
+ * qla1200_error_action
+ *    The function will attempt to perform a specified error action and
+ *    wait for the results (or time out).
  *
  * Input:
  *      cmd = Linux SCSI command packet of the command that cause the
  *            bus reset.
- *      flags = SCSI bus reset option flags (see scsi.h)
+ *      action = error action to take (see action_t)
  *
  * Returns:
- *      DID_RESET in cmd.host_byte of aborted command(s) 
+ *      SUCCESS or FAILED
  *
  * Note:
  *      Resetting the bus always succeeds - is has to, otherwise the
